class PcKey extends React.Component
{
  constructor(props)
  {
    super(props);
    this.state =
      {
        width:props.width,
        padHorizontal:16,
        padVertical:16
      }

    this.buttonBackground = React.createRef();
    this.buttonContainer = React.createRef();
  }

  static predictSize(label)
  {
    var e = document.createElement("canvas");
    var ctx = e.getContext("2d");
    ctx.font = PcConfig.scenario.fontSize + " " + PcConfig.scenario.fontFamily;
    var t= ctx.measureText(label);
    return t.width;
  }

  getWidth()
  {
    return this.buttonBackground.current.getBoundingClientRect().width;
  }

  setWidth(w)
  {
    this.setState({width: w-(2*this.state.padHorizontal*PcConfig.renderSize)-2*PcConfig.scenario.buttonsBorderWidth});
  }

  onClick(e)
  {
    if (e.type === 'touchend')
    {
      //e.stopPropagation();
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    PcConfig.sounds.keyboard.play();
    if (this.props.onClick) this.props.onClick();
  }

  render()
  {
    var backgroundColor = this.props.backgroundColor;
    var textColor = this.props.color;
    var grow = this.props.grow ? this.props.grow : 1;

    var fontSize = (this.props.label=="⌫" || this.props.label=="⇧") ? PcConfig.scenario.fontSizeKeyboardSmall : PcConfig.scenario.fontSizeKeyboard;

    if (PcConfig.scenario.buttonsStyle=="rounded")
    {
      var borderRadius = 12 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="roundedMore")
    {
      var borderRadius = 36 * PcConfig.renderSize;
    }
    else
    {
      var borderRadius = 0;
    }

    return e('div',
        {
          className:"pcbuttoncontainer",
          ref:this.buttonContainer,
          style:
          {
            opacity:1,
            left: this.props.x,
            top:this.props.y,
            marginLeft: this.props.spacingH,
            marginRight: this.props.spacingH,
            marginTop: this.props.spacingV,
            marginBottom: this.props.spacingV,
            flexGrow:grow,
            flexShrink:1,
            flexBasis:0,
          }
        },
        e('div',
          {
            className:"pcbutton",
            ref:this.buttonBackground,
            style:
              {
                position:"relative",
                width:this.state.width,
                height:this.props.height,
                backgroundColor:backgroundColor,
                borderRadius:borderRadius,
                paddingTop:this.state.padVertical*PcConfig.renderSize,
                paddingBottom:this.state.padVertical*PcConfig.renderSize,
                paddingLeft:this.state.padHorizontal*PcConfig.renderSize,
                paddingRight:this.state.padHorizontal*PcConfig.renderSize,
                overflow:"auto",
                fontFamily:"Arial",
                fontSize:fontSize,
                color:textColor,
                verticalAlign: "middle",
                textAlign: "center"
              },
              onClick:(e)=>{this.onClick(e)},
              onTouchEnd:(e)=>{this.onClick(e)},
              dangerouslySetInnerHTML:{__html:this.props.label}
          }
        )
    );
  }
}
