class PcRemoveBg extends React.Component
{
    static getTimeout(format_index) 
    {
        return this.getDict(format_index).timeout;
    }
    static isOptional(format_index)
    {
        let mode = this.getDict(format_index).mode;
        return  (mode == "optional_on" || mode == "optional_off");
    }
    
    static isOn(format_index)
    {
        let mode = this.getDict(format_index).mode;
        return (mode == "on" || mode == "optional_on");
    } 
    static getDict(format_index)
    {
        let formats = PcConfig.screen.format.formats;
        PcDbg.log(REMOVEDBG, "format index is ", format_index, "vs formats length", formats.length);
        return formats[format_index].removeBg;
    }
    
    static async queueJob(in_filename, is_id, ttl_seconds, onDone, id_photo, outFormat, in_bg_filename=undefined) //
    {
        let params = {};
        let out_filename = undefined;       
        PcDbg.log(REMOVEDBG, "entering with args ttl_seconds", ttl_seconds);
        /* mandatory args */
        params['in_filename'] = in_filename;
        params["in_bg_filename"] = in_bg_filename;
        params["ttl_seconds"] = ttl_seconds;
        params["is_id"] = is_id;
        params["api_key"] = PcConfig.screen.format.removeBgApiKey;
        params["out_format"] = outFormat;
        params["date"] = PcConfig.formatDate(new Date());
        
        if (params["api_key"] == "") {
            PcDbg.log(true, "NO REMOVEBG API KEY PROVIDED! This job will fail but we let the machinery recover gracefully");
        }
        
        
        /*optional args */
        if (id_photo) {
            params["id_photo"] = id_photo;
        }
        /*out_field_name will be handled by queue_job_removebg.php*/
        
        var post_str =JSON.stringify(params);
        
        PcDbg.log(REMOVEDBG, "remove bg params are:", post_str);
        
        try { 
            const removebg_success_data = await  $.ajax({
                url: PcConfig.host + 'scripts/queue_job_removebg.php?',
                type: "POST",
                data: {json_data : post_str},
                timeout:ttl_seconds + 1000
            });
            var return_data = JSON.parse(removebg_success_data);
            PcDbg.log(REMOVEDBG, "after queue_job_removebg.php, got data", removebg_success_data, "ie return data", JSON.stringify(return_data));
            if(return_data["error_code"] == "ok") {
                out_filename = return_data["out_filename"];
            }
        } catch (error) {
            PcDbg.log(true, "Ajax request error", error);
        }
        /*
        $.ajax({
            url: PcConfig.host + 'scripts/queue_job_removebg.php?',
            type: "POST",
            async: false, // FIXME ASAP
            data: {json_data : post_str},
            timeout:ttl_seconds + 1000,
            success: (removebg_success_data)=>{
                var return_data = JSON.parse(removebg_success_data);
                PcDbg.log(REMOVEDBG, "after queue_job_removebg.php, got data", removebg_success_data, "ie return data", JSON.stringify(return_data));
                if(return_data["error_code"] == "ok") {
                    out_filename = return_data["out_filename"];
                }
                
                //if (onDone) {         
                //    onDone(out_filename); 
                //}
                
            },
            error: (xhr, status, err)=>{  
                
                //if (onDone) {
                //    onDone(out_filename);
                //}
                
            }
        });
        */
        PcDbg.log(REMOVEDBG, "exiting with out_filename", out_filename);
        return out_filename;
    }
    
}

