<?php
define('DIGICAMDIR', 'C:/www/scripts/Default/');
    
$dir = opendir(DIGICAMDIR);
$files = array();
while ($files[] = readdir($dir));
closedir($dir);

sort($files);
    
foreach ($files as $file)
{
    $ext = strtolower(substr($file, -4));

    if ($ext==".jpg" && $file !="" && $file!="." && $file!="..")
    {           
        $src_filename = DIGICAMDIR . $file;
        $dest_filename = "./photographe/" . $file;
        
        $infos = exif_read_data($src_filename, "IFDO");
        
        $imagesource = imagecreatefromjpeg($src_filename);
            
        $angle = 0;
        
        if ($infos && $infos['Orientation'])
        {
            if ($infos['Orientation']==3) { $angle = -180;}
            else if ($infos['Orientation']==6) {$angle = -90;}
            else if ($infos['Orientation']==8) {$angle = 90;}
            else {$angle=0;}
        }
        
	    $photowidth = imagesx($imagesource);
        $photoheight = imagesy($imagesource);

        $finalwidth = 1800;
        $finalheight = 1200;
        
        $finalratio = $finalheight/$finalwidth;

        $px = 0;
        $py = intval(($photoheight - ($photowidth*$finalratio))/2);

        $imagecroppedandresized = imagecreatetruecolor($finalwidth, $finalheight);
        imagecopyresampled($imagecroppedandresized, $imagesource, 0, 0, $px, $py, $finalwidth, $finalheight, $photowidth, intval($photowidth*$finalratio));
        
        if ($angle!=0) 
        {
            $imagecroppedandresized = imagerotate($imagecroppedandresized, $angle, 0);
            $finalwidth = imagesx($imagecroppedandresized);
            $finalheight = imagesy($imagecroppedandresized);
        }
        
        imagejpeg($imagecroppedandresized, $dest_filename, 95);
        
        imagedestroy($imagesource);
        imagedestroy($imagecroppedandresized);

        @unlink($src_filename);
    }
}

$dir = opendir("photographe");
$files = array();
while ($files[] = readdir($dir));
closedir($dir);

sort($files);
$files = array_splice($files, -100);

$xml = "<xml>\n\n";

for ($i=0; $i<count($files); $i++)
{
    $file = $files[$i];    

    if ($file !="" && $file!="." && $file!="..")
    {
	    $url = "http://localhost/scripts/photographe/".$file;
        
        $size = getimagesize($url);
        $sx = $size[0];
        $sy = $size[1];
        
        $xml .= "<photo>\n";
        $xml .= "<url>$url</url>\n<size>".$sx."x".$sy."</size>\n";
        for ($g=0; $g<5; $g++) $xml .= "<gif>$url</gif>\n";
        $xml .= "</photo>\n\n";
    }
}

$xml .= "\n</xml>";

echo $xml;
?>